#!/usr/bin/perl
# Filename:      mailarchiv-import-users.pl
# Version:       0.1
#
# Copyright (C) 2004, Megabit Informationstechnik GmbH <info@megabit.net>
#
# Description:   This Perl script was used to import a complete maildomain into 
#                the mailarchiv and grant all users access to their own sent and 
#                received emails.
# 
#                 The script expects an input via pipe with a username and password devided by a ';'.
#                  This is commonly used in csv files
#
# Author:        Daniel Weuthen <dw@megabit.net>
# Created at:    Thu Sep 02 13:48:49 2004
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of the GNU General
# Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your
# option) any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place,
# Suite 330, Boston, MA  02111-1307  USA


$domain = "mydomain.com"

$db_host = "localhost";
$db_database = "mailarchiv";
$db_user = "mailarchiv";
$db_pass = "mysecret password";

#################### no changed should be needed beyond this line ####################

use DBI;

$dbh = DBI->connect("DBI:mysql:$db_database:$db_host:$db_sp", "$db_user", "$db_pass") or &my_error("ERROR: ".$DBI::errstr);

while (<>) {
  next if /^#/;
  next if /^$/;
  $line = $_;
  chomp($line);
  ($user,$pass,$trash) = split(";",$line);
  if ( ( length($user) != 0 ) && ( length($pass) != 0 ) ) {
    $user = "$user\@$domain";
    print "Creating user '$user' with password '$pass'\n";

    my $SQL = "SELECT id FROM address WHERE address='$user'";
    my $cursor = $dbh->prepare($SQL) or &my_error("ERROR: ".$dbh->errstr);
    $cursor->execute or &my_error("ERROR: ".$dbh->errstr);
    @row = $cursor->fetchrow_array;
    $rowlen=$#row+1;

    if ($rowlen == 0) {
      # Create new user
      my $SQL = "INSERT INTO users VALUES ('','$user',SHA1('$pass'),'lurker')";
      my $cursor = $dbh->prepare($SQL) or &my_error("ERROR: ".$dbh->errstr);
      $cursor->execute or &my_error("ERROR: ".$dbh->errstr);

      $lastuid = $cursor->{mysql_insertid};

      # Add addresses
      my $SQL = "INSERT INTO address VALUES ('','$user')";
      my $cursor = $dbh->prepare($SQL) or &my_error("ERROR: ".$dbh->errstr);
      $cursor->execute or &my_error("ERROR: ".$dbh->errstr);

      $lastaid = $cursor->{mysql_insertid};
      # allow access to own address
      my $SQL = "INSERT INTO access VALUES ('$lastuid','$lastaid')";
      my $cursor = $dbh->prepare($SQL) or &my_error("ERROR: ".$dbh->errstr);
      $cursor->execute or &my_error("ERROR: ".$dbh->errstr);

      print "User '$user' with UID '$lastuid' added successfuly.\n";
    } else {
      my $SQL = "UPDATE users SET password=SHA1('$pass') WHERE name='$user'";
      my $cursor = $dbh->prepare($SQL) or &my_error("ERROR: ".$dbh->errstr);
      $cursor->execute or &my_error("ERROR: ".$dbh->errstr);

      print "User '$user' exists. Updating password.\n";
    }
  } # if (len
} # while
$dbh->disconnect;

# error handling
sub my_error
{
  my $error_msg = shift;
  print $error_msg;
  exit 1
}
